
/*
 * extrude.h
 *
 * FUNCTION:
 * prototypes for privately used subroutines for the tubing library
 *
 * HISTORY:
 * Linas Vepstas 1991
 */
#define do_GLE_time_outs
#ifdef do_GLE_time_outs
#include <windows.h> // this is just for Sleep()
#include <time.h>
extern gleDouble dTimeOutPerTubeInSecs;
extern void  SetTimeOutPerTube(gleDouble dmax_time);
extern gleDouble dSleepAtTimeInMilliseconds,dSleepForTimeInMilliseconds;
extern void( __cdecl *SleepAtProc )( gleDouble);
void  SetSleepAt
 (gleDouble dSleepAtInMilliseconds,gleDouble dSleepForInMilliseconds
 ,void( __cdecl *NewSleepAtProc )( gleDouble)
 );
extern char( __cdecl *StopProc )( void);
extern void  SetStopProc(char( __cdecl *proc )( void));

extern void gleCleanUpMalloc(void);
extern void gleCleanUpMallocEndOfApp(void);
extern void gleFree(void *pvoid);
extern void gleInitMalloc(void);
extern void *gleMalloc(size_t size);
extern void gleDeleteGC (void);
#define INIT_TIME_OUT_CHECK\
   int nloops=0;\
   DWORD dwtstart=timeGetTime();\
   DWORD dwtwas=dwtstart;

#define DO_TIME_OUT_CHECK\
 {\
  if((dTimeOutPerTubeInSecs>1e-10)\
    ||(dSleepAtTimeInMilliseconds>1e-10)\
    )\
  if(nloops%4==0)\
  {\
   DWORD dwt=timeGetTime();\
   DWORD dwtok=(DWORD)floor(0.5+dTimeOutPerTubeInSecs*1000);\
   if(dwtok>1)\
   if(dwt-dwtstart>dwtok)\
    break;\
    if(StopProc)\
    if(StopProc())\
     break;\
   if(dSleepAtTimeInMilliseconds>1e-3)\
   if(dwt-dwtwas>dSleepAtTimeInMilliseconds)\
   {\
    if(SleepAtProc)\
     SleepAtProc((DWORD)floor(0.5+dSleepForTimeInMilliseconds));\
    else\
    {\
     int i=0;\
     char do_break=0;\
     DWORD dwtstart_sleep=timeGetTime();\
     for(i=0;i<1000;i++)\
     {\
      DWORD dwt2=timeGetTime();\
      double dtime_left=(dSleepForTimeInMilliseconds-(dwt2-dwtstart_sleep));\
      DWORD dwtime_left=(DWORD)floor(0.5+dtime_left);\
      if(dwtime_left==0||dtime_left<0)\
      break;\
      if(dwtok>1)\
      if(dwt2-dwtstart>dwtok)\
      {do_break=1;break;}\
      Sleep(dwtime_left);\
     }\
     if(do_break)\
      break;\
    }\
    dwtwas=dwt;\
   }\
  }\
  nloops++;\
 }

#else
#define INIT_TIME_OUT_CHECK
#define DO_TIME_OUT_CHECK
#endif

#ifndef M_PI
#define M_PI  3.14159265358979323846
#endif

/* ============================================================ */
/* 
 * Provides choice of calling subroutine, vs. invoking macro.
 * Basically, inlines the source, or not.
 * Trades performance for executable size.
 */

#define INLINE_INTERSECT
#ifdef INLINE_INTERSECT
#define INNERSECT(sect,p,n,v1,v2) { INTERSECT(sect,p,n,v1,v2); }
#else
#define INNERSECT(sect,p,n,v1,v2) intersect(sect,p,n,v1,v2)
#endif /* INLINE_INTERSECT */

/* ============================================================ */
/* The folowing defines give a kludgy way of accessing the qmesh primitive */

/*
#define bgntmesh _emu_qmesh_bgnqmesh
#define endtmesh _emu_qmesh_endqmesh
#define c3f _emu_qmesh_c3f
#define n3f _emu_qmesh_n3f
#define v3f _emu_qmesh_v3f
*/

/* ============================================================ */

extern void up_sanity_check (gleDouble up[3],      /* up vector for contour */
                      int npoints,              /* numpoints in poly-line */
                      gleDouble point_array[][3]);   /* polyline */


extern void draw_raw_style_end_cap (int ncp,     /* number of contour points */
                             gleDouble contour[][2],     /* 2D contour */
                             gleDouble zval,             /* where to draw cap */
                             int frontwards);    /* front or back cap */

extern void draw_round_style_cap_callback (int iloop,
                                  double cap[][3],
                                  float face_color[3],
                                  gleDouble cut_vector[3],
                                  gleDouble bisect_vector[3],
                                  double norms[][3],
                                  int frontwards);

extern void draw_angle_style_front_cap (int ncp,
                           gleDouble bi[3],
                           gleDouble point_array[][3]);

extern void extrusion_raw_join (int ncp,        /* number of contour points */
                         gleDouble contour[][2],    /* 2D contour */
                         gleDouble cont_normal[][2],/* 2D contour normal vecs */
                         gleDouble up[3],           /* up vector for contour */
                         int npoints,           /* numpoints in poly-line */
                         gleDouble point_array[][3],        /* polyline */
                         float color_array[][3],        /* color of polyline */
                         gleDouble xform_array[][2][3]);  /* 2D contour xforms */


extern void extrusion_round_or_cut_join (int ncp, /* number of contour points */
                         gleDouble contour[][2],    /* 2D contour */
                         gleDouble cont_normal[][2],/* 2D contour normal vecs */
                           gleDouble up[3],         /* up vector for contour */
                           int npoints,         /* numpoints in poly-line */
                           gleDouble point_array[][3],      /* polyline */
                           float color_array[][3],      /* color of polyline */
                           gleDouble xform_array[][2][3]);  /* 2D contour xforms */


extern void extrusion_angle_join (int ncp,      /* number of contour points */
                         gleDouble contour[][2],    /* 2D contour */
                         gleDouble cont_normal[][2],/* 2D contour normal vecs */
                           gleDouble up[3],         /* up vector for contour */
                           int npoints,         /* numpoints in poly-line */
                           gleDouble point_array[][3],      /* polyline */
                           float color_array[][3],      /* color of polyline */
                           gleDouble xform_array[][2][3]);  /* 2D contour xforms */

/* -------------------------- end of file -------------------------------- */

extern void( __cdecl *gleColourPosProc)( int ipos,int npts);
extern void  Set_gleColourPosProc(void( __cdecl *proc )(  int,int));

#define CL_EXCEPTION_HANDLER
#ifdef CL_EXCEPTION_HANDLER

extern void( __cdecl *gleExceptionHandler)(int nexception,char *szRoutineEtcName);
extern void  Set_gleExceptionHandler(void( __cdecl *proc )(int,char *));
extern int gle_n_except;

extern int gleEval_Exception ( int n_except );

#define DO_ENTER_TRY_BLOCK\
 __try\
 {

#define DO_EXIT_TRY_BLOCK_PROC(szName)\
 }\
 __except(gleEval_Exception(GetExceptionCode( )))\
 {\
  if(gleExceptionHandler)\
  gleExceptionHandler(gle_n_except,szName);\
 }

#else
#define DO_ENTER_TRY_BLOCK
#define DO_EXIT_TRY_BLOCK_PROC
#endif

#define DO_COLOUR_POS_PROC(ipos,npts)\
{if(gleColourPosProc)gleColourPosProc(ipos,npts);}
